package com.tanpu.feo.feojob.service;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tanpu.feo.feojob.entity.DepartmentEntity;
import com.tanpu.feo.feojob.mapper.DepartmentMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 部门信息表ServiceImp
 *
 * @author zejia zj wu 2021年05月18日
 * @version 1.0
 */
@Service("departmentService")
@Slf4j
public class DepartmentService extends ServiceImpl<DepartmentMapper, DepartmentEntity> {

	@Autowired
	private DepartmentMapper departmentMapper;

	public List<DepartmentEntity> findDepartmentByOrgId(String orgId) {
		return departmentMapper.selectList(Wrappers.lambdaQuery(DepartmentEntity.class).eq(DepartmentEntity::getOrgId, orgId).eq(DepartmentEntity::getDeleteTag,"0"));
	}
}
