package com.tanpu.feo.feojob.service;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tanpu.feo.feojob.entity.EmployeeEntity;
import com.tanpu.feo.feojob.mapper.EmployeeMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 员工信息表ServiceImp
 *
 * @author zejia zj wu 2021年05月18日
 * @version 1.0
 */
@Service("employeeService")
@Slf4j
public class EmployeeService extends ServiceImpl<EmployeeMapper, EmployeeEntity> {

	@Autowired
	private EmployeeMapper employeeMapper;

	public List<EmployeeEntity> getEmployeeSListByOrgId(String orgId) {
		return employeeMapper.selectList(Wrappers.lambdaQuery(EmployeeEntity.class).eq(EmployeeEntity::getOrgId, orgId).eq(EmployeeEntity::getDeleteTag,"0"));
	}
}
