package com.tanpu.feo.feojob.service;

import com.tanpu.feo.feojob.dto.WorkDataDto;
import com.tanpu.feo.feojob.entity.*;
import com.tanpu.feo.feojob.mapper.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
@Slf4j
public class OrgSyncByWxcpService {
    @Resource
    private UserInfoService userInfoService;
    @Resource
    private DepartmentEmployeeService departmentEmployeeService;
    @Resource
    private EmployeeService employeeService;
    @Resource
    private DepartmentService departmentService;
    @Resource
    private EmployeeRoleService employeeRoleService;


    @Transactional
    public List<IfaAssetsEntity> execute(WorkDataDto<UserInfoEntity> workUserInfo, WorkDataDto<EmployeeEntity> workEmployee, WorkDataDto<DepartmentEntity> workDepartment,
                                         WorkDataDto<DepartmentEmployeeEntity> workDepartmentEmployee, WorkDataDto<EmployeeRoleEntity> workEmployeeRole) {
        ArrayList<IfaAssetsEntity> assetsArrayList = new ArrayList<>();
        Date now = new Date();
        log.info("==========开始 执行数据修改==========");
        // 1
        List<UserInfoEntity> workUserInfoInsertList = workUserInfo.getInsertList();
        for (UserInfoEntity userInfoEntity : workUserInfoInsertList) {
            userInfoEntity.setCreateby("SYS");
            userInfoEntity.setCreatetime(now);
            userInfoEntity.setUpdateby("SYS");
            userInfoEntity.setUpdatetime(now);
            userInfoEntity.setDeletetag("0");
        }
        userInfoService.saveBatch(workUserInfoInsertList);

        List<UserInfoEntity> workUserInfoUpdateList = workUserInfo.getUpdateList();
        for (UserInfoEntity userInfoEntity : workUserInfoUpdateList) {
            userInfoEntity.setUpdateby("SYS");
            userInfoEntity.setUpdatetime(now);
            userInfoEntity.setDeletetag("0");
        }
        userInfoService.updateBatchById(workUserInfoUpdateList);

        List<UserInfoEntity> workUserInfoDeleteList = workUserInfo.getDeleteList();
        for (UserInfoEntity userInfoEntity : workUserInfoDeleteList) {
            userInfoEntity.setUpdateby("SYS");
            userInfoEntity.setUpdatetime(now);
            userInfoEntity.setDeletetag("1");
        }
        userInfoService.updateBatchById(workUserInfoDeleteList);

        //2
        List<EmployeeEntity> workEmployeeInsertList = workEmployee.getInsertList();
        for (EmployeeEntity employeeEntity : workEmployeeInsertList) {
            employeeEntity.setCreateBy("SYS");
            employeeEntity.setCreateTime(now);
            employeeEntity.setUpdateBy("SYS");
            employeeEntity.setUpdateTime(now);
            employeeEntity.setDeleteTag("0");
            IfaAssetsEntity ifaAssetsEntity = new IfaAssetsEntity();
            ifaAssetsEntity.setIfaId(employeeEntity.getEmployeeId());
            ifaAssetsEntity.setId(employeeEntity.getEmployeeId());
            ifaAssetsEntity.setCreateTime(now);
            ifaAssetsEntity.setCreateBy("SYS");
            ifaAssetsEntity.setUpdateTime(now);
            ifaAssetsEntity.setUpdateBy("SYS");
            ifaAssetsEntity.setDeleteTag("0");
            assetsArrayList.add(ifaAssetsEntity);
        }
        employeeService.saveBatch(workEmployeeInsertList);


        List<EmployeeEntity> workEmployeeDeleteList = workEmployee.getDeleteList();
        for (EmployeeEntity employeeEntity : workEmployeeDeleteList) {
            employeeEntity.setUpdateBy("SYS");
            employeeEntity.setUpdateTime(now);
            employeeEntity.setDeleteTag("1");
        }
        employeeService.updateBatchById(workEmployeeDeleteList);

        List<EmployeeEntity> workEmployeeUpdateList = workEmployee.getUpdateList();
        for (EmployeeEntity employeeEntity : workEmployeeUpdateList) {
            employeeEntity.setUpdateBy("SYS");
            employeeEntity.setUpdateTime(now);
            employeeEntity.setDeleteTag("0");
        }
        employeeService.updateBatchById(workEmployeeUpdateList);

        //3
        List<DepartmentEntity> workDepartmentInsertList = workDepartment.getInsertList();
        for (DepartmentEntity departmentEntity : workDepartmentInsertList) {
            departmentEntity.setCreateBy("SYS");
            departmentEntity.setCreateTime(now);
            departmentEntity.setUpdateBy("SYS");
            departmentEntity.setUpdateTime(now);
            departmentEntity.setDeleteTag("0");
        }
        departmentService.saveBatch(workDepartmentInsertList);

        List<DepartmentEntity> workDepartmentDeleteList = workDepartment.getDeleteList();
        for (DepartmentEntity departmentEntity : workDepartmentDeleteList) {
            departmentEntity.setUpdateBy("SYS");
            departmentEntity.setUpdateTime(now);
            departmentEntity.setDeleteTag("1");
        }
        departmentService.updateBatchById(workDepartmentDeleteList);

        List<DepartmentEntity> workDepartmentUpdateList = workDepartment.getUpdateList();
        for (DepartmentEntity departmentEntity : workDepartmentUpdateList) {
            departmentEntity.setUpdateBy("SYS");
            departmentEntity.setUpdateTime(now);
            departmentEntity.setDeleteTag("0");
        }
        departmentService.updateBatchById(workDepartmentUpdateList);

        //4
        List<DepartmentEmployeeEntity> workDepartmentEmployeeInsertList = workDepartmentEmployee.getInsertList();
        for (DepartmentEmployeeEntity departmentEmployeeEntity : workDepartmentEmployeeInsertList) {
            departmentEmployeeEntity.setCreateBy("SYS");
            departmentEmployeeEntity.setCreateTime(now);
            departmentEmployeeEntity.setUpdateBy("SYS");
            departmentEmployeeEntity.setUpdateTime(now);
            departmentEmployeeEntity.setDeleteTag("0");
        }
        departmentEmployeeService.saveBatch(workDepartmentEmployeeInsertList);

        List<DepartmentEmployeeEntity> workDepartmentEmployeeDeleteList = workDepartmentEmployee.getDeleteList();
        for (DepartmentEmployeeEntity departmentEmployeeEntity : workDepartmentEmployeeDeleteList) {
            departmentEmployeeEntity.setUpdateBy("SYS");
            departmentEmployeeEntity.setUpdateTime(now);
            departmentEmployeeEntity.setDeleteTag("1");
        }
        departmentEmployeeService.updateBatchById(workDepartmentEmployeeDeleteList);

        List<DepartmentEmployeeEntity> workDepartmentEmployeeUpdateList = workDepartmentEmployee.getUpdateList();
        for (DepartmentEmployeeEntity departmentEmployeeEntity : workDepartmentEmployeeUpdateList) {
            departmentEmployeeEntity.setUpdateBy("SYS");
            departmentEmployeeEntity.setUpdateTime(now);
            departmentEmployeeEntity.setDeleteTag("0");
        }
        departmentEmployeeService.updateBatchById(workDepartmentEmployeeUpdateList);

        //5
        List<EmployeeRoleEntity> workEmployeeRoleInsertList = workEmployeeRole.getInsertList();
        for (EmployeeRoleEntity employeeRoleEntity : workEmployeeRoleInsertList) {
            employeeRoleEntity.setCreateBy("SYS");
            employeeRoleEntity.setCreateTime(now);
            employeeRoleEntity.setUpdateBy("SYS");
            employeeRoleEntity.setUpdateTime(now);
            employeeRoleEntity.setDeleteTag("0");
        }
        employeeRoleService.saveBatch(workEmployeeRoleInsertList);

        List<EmployeeRoleEntity> workEmployeeRoleDeleteList = workEmployeeRole.getDeleteList();
        for (EmployeeRoleEntity employeeRoleEntity : workEmployeeRoleDeleteList) {
            employeeRoleEntity.setUpdateBy("SYS");
            employeeRoleEntity.setUpdateTime(now);
            employeeRoleEntity.setDeleteTag("1");
        }
        employeeRoleService.updateBatchById(workEmployeeRoleDeleteList);

        List<EmployeeRoleEntity> workEmployeeRoleUpdateList = workEmployeeRole.getUpdateList();
        for (EmployeeRoleEntity employeeRoleEntity : workEmployeeRoleUpdateList) {
            employeeRoleEntity.setUpdateBy("SYS");
            employeeRoleEntity.setUpdateTime(now);
            employeeRoleEntity.setDeleteTag("0");
        }
        employeeRoleService.updateBatchById(workEmployeeRoleUpdateList);
        log.info("==========结束 执行数据修改==========");
        return assetsArrayList;
    }

}

