package com.tanpu.feo.feojob.service.jyzy;


import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.tanpu.feo.feojob.entity.jyzy.JyzyUserInfoEntity;
import com.tanpu.feo.feojob.mapper.jyzy.JyzyUserInfoMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * ServiceImp
 *
 * @author zejia zj wu 2021年05月26日
 * @version 1.0
 */
@Service
@Slf4j
@DS("jyzy_fatools")
public class JyzyUserInfoService {

	@Autowired
	private JyzyUserInfoMapper JyzyUserInfoMapper;

	public List<JyzyUserInfoEntity> getUserListByOrgId(String orgId) {
		LambdaQueryWrapper<JyzyUserInfoEntity> queryWrapper = Wrappers.lambdaQuery(JyzyUserInfoEntity.class)
				.eq(JyzyUserInfoEntity::getOrgId, orgId)
				.eq(JyzyUserInfoEntity::getDeletetag, "0")
				.ne(JyzyUserInfoEntity::getUiShenfen, 2);
		return JyzyUserInfoMapper.selectList(queryWrapper);
	}
}
